/*一些基础的js方法，基础的业务js方法在lib.js里*/
$.ajaxSetup({
    xhrFields:{
        withCredentials:true
    },
    crossDomain:true,
    headers:{
        "_sign":localStorage.getItem("_sign")   // TP不用改动任何代码
    },
    beforeSend: function (XMLHttpRequest) {//ajax请求之前
        if(this.url.indexOf(".json") >=0 && (this.url.indexOf("add") >=0 || this.url.indexOf("edit") >=0)){
            layui.layer.load(1);
        }
        //$("#loading_message").show();
    },
    complete: function (XMLHttpRequest, textStatus) {//responseText
        if(this.url.indexOf(".json") >=0 && (this.url.indexOf("add") >=0 || this.url.indexOf("edit") >=0)){
            layui.layer.closeAll('loading');//关闭加载层
        }
        if (!$.isEmpty(XMLHttpRequest.responseJSON) && XMLHttpRequest.responseJSON.code == 401) {
            layer.msg("网页已过期，请重新登陆！", {
                offset: ['50%'],
                icon: 2,
                time: 2000 //2秒关闭（如果不配置，默认是3秒）
            }, function () {
                window.open(Common.ctxPath);
            });
            return;
        }
        if (XMLHttpRequest.statusText == 'error' && !$.isEmpty(XMLHttpRequest.responseText)) {
            var r = $.parseJSON(XMLHttpRequest.responseText);
            if (r.code == 401) {
                layer.msg("网页已过期，请重新登陆！", {
                    offset: ['50%'],
                    icon: 2,
                    time: 2000 //2秒关闭（如果不配置，默认是3秒）
                }, function () {
                    window.open(Common.ctxPath);
                });
            }
            return;
        }
    },
    error: function () {
        //ajax请求失败
    },
});

//日期格式化
Date.prototype.format = function (format) {
    var d = this, o = {
        "M+": d.getMonth() + 1,
        "d+": d.getDate(),
        "H+": d.getHours(),
        "m+": d.getMinutes(),
        "s+": d.getSeconds(),
        w: ["日", "一", "二", "三", "四", "五", "六"][d.getDay()]
    };
    if (/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (d.getFullYear() + "").substr(4 - RegExp.$1.length))
    }
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length))
        }
    }
    return format
};

var Common = {
    ctxPath: "",
    version: "",
    log: function (info) {
        console.log(info);
    },
    alert: function (info, iconIndex) {
        parent.layer.msg(info, {
            icon: iconIndex
        });


    },
    info: function (info) {
        Common.alert(info, 0);
    },
    success: function (info) {
        Common.alert(info, 1);
    },
    error: function (info) {
        Common.openConfirm(info)
    },
    post: function (url, paras, next) {
        $.ajax({
            url: Common.ctxPath + url,
            type: "POST",
            data: paras,
            success: function (rsp) {
                if (rsp.code != 0) {
                    Common.error(rsp.msg);
                } else {
                    //成功
                    if (next != null) {
                        next(rsp.data);
                    } else {
                        Common.success(rsp.responseJSON.msg);
                    }
                }
            },
            error: function (rsp) {
                Common.error(rsp.responseJSON.msg);
            }
        })

    },
    getOneFromTable: function (layuiTable, tableId) {
        var checkStatus = layuiTable.checkStatus(tableId)
            , data = checkStatus.data;
        if (data.length == 0) {
            Common.info("请选中一条记录");
        } else if (data.length > 1) {
            Common.info("只能选中一条记录")
        } else {
            return data[0];
        }
    },
    getMoreDataFromTable: function (layuiTable, tableId) {
        var checkStatus = layuiTable.checkStatus(tableId)
            , data = checkStatus.data;
        if (data.length == 0) {
            Common.info("请选中记录");
        } else {
            return data;
        }
    },
    openDlg: function (url, title, orderId) {
        // $.ajax({
        //     url:Common.ctxPath + url,
        //     type: 'get',
        //     dataType:"text",
        //     success: function (result) {
        //         var tex = result;
        //         var index = layer.open({
        //             type: 2,
        //             content: "<div>1234</div>",
        //             title: title,
        //             maxmin: false
        //         });
        //         layer.full(index);
        //     }
        // });
        var index = layer.open({
            type: 2,
            content: Common.ctxPath + url,
            title: title || '',
            maxmin: false
            , cancel: function () {
                // 右上角关闭事件的逻辑
                if (!$.isEmpty(orderId)) {
                    Lib.cancelAndCross({orderId: orderId});
                }
            }
        });
        layer.full(index);
    },
    topOpenDlg: function (url, title) {
        var index = top.layer.open({
            type: 2,
            content: Common.ctxPath + url,
            title: title,
            area: ['100%', '100%'],
            maxmin: false
        });
        layer.full(index);
    },
    openConfirm: function (content, callback, callBackNo) {
        var index = layer.confirm(content, {
            btn: ['确认', '取消'] //按钮
        }, function () {
            if (callback != null) {
                callback();
            }
            layer.close(index);
        }, function () {
            if (callBackNo != null) {
                callBackNo()
            }
            layer.close(index);
        });

    },
    openPrompt: function (title, defaultValue, callback) {
        layer.prompt({title: title, formType: 0, value: defaultValue}, function (value, index, elem) {
            layer.close(index);
            callback(value);
        });
    },
    concatBatchId: function (data, idField) {//获取数组中的相应值
        var ids = ""
        var name = idField == null ? "id" : idField;
        for (var i = 0; i < data.length; i++) {
            var item = data[i];
            ids = ids + item[name];
            if (i != data.length - 1) {
                ids = ids + ","
            }
        }
        return ids;
    },
    sessionTimeoutRegistry: function () {
        $.ajaxSetup({
            contentType: "application/x-www-form-urlencoded;charset=utf-8",
            complete: function (XMLHttpRequest, textStatus) {
                //通过XMLHttpRequest取得响应头，sessionstatus，
                var sessionstatus = XMLHttpRequest.getResponseHeader("sessionstatus");
                if (sessionstatus == "timeout") {
                    //如果超时就处理 ，指定要跳转的页面
                    window.location = Common.ctxPath + "/global/sessionError";
                }
            }
        });
    },
    initValidator: function (formId, fields) {
        $('#' + formId).bootstrapValidator({
            feedbackIcons: {
                valid: 'glyphicon glyphicon-ok',
                invalid: 'glyphicon glyphicon-remove',
                validating: 'glyphicon glyphicon-refresh'
            },
            fields: fields,
            live: 'enabled',
            message: '该字段不能为空'
        });
    },
    getDate: function (date, pattern) { //获取相应格式的时间  时间格式化
        if (date == null || date == '') {
            return "";
        } else {
            if (pattern) {
                if(date.indexOf("年") >= 0 || date.indexOf("月") >= 0 || date.indexOf("日") >= 0 || date.indexOf("时") >= 0 || date.indexOf("分") >= 0 || date.indexOf("秒") >= 0){
                    return date;
                }else {
                    date = date.length > 8?date:date.length == 8?("1949/10/01 " + date):date;
                    return new Date(date).format(pattern);
                }
            } else {
                return date.substring(0, 10);
            }

        }
    }, postAjax: function (url, paras) {
        var r = "";
        $.ajax({
            url: Common.ctxPath + url,
            async: false,
            type: "POST",
            data: paras,
            dataType: "json",
            success: function (rsp) {
                r = rsp;
            },
            error: function (rsp) {
                r = rsp.responseJSON;
                console.log("请求失败！");
                return;
            }
        });
        return r;
    },getAjax: function (url, paras) {
        var r = "";
        $.ajax({
            url: Common.ctxPath + url,
            async: false,
            type: "GET",
            data: paras,
            dataType: "json",
            success: function (rsp) {
                r = rsp;
            },
            error: function (rsp) {
                r = rsp.responseJSON;
                console.log("请求失败！");
                return;
            }
        });
        return r;
    },parentOpenDlg: function (url, title) {
        layer.open({
            type: 2,
            title:title,
            shadeClose:'true',
            offset: ['5%', '5%'],
            area: ['90%', '90%'],
            scrollbar:'false',
            btnAlign: 'c',
            content: Common.ctxPath + url
        });
    },noticeOpen:function (url,title){
        var htm = "<div style='padding: 20px;'><h1>平台业务责任划分规则</h1><p>一：证书、职位匹配过程，视为一次快速的协议签订过程，既然是协议，应该遵循以下原则：</p>" +
            "<p style='font-weight: 800;'>1、录入与实际一致原则。人才、企业双方都要对录入系统的信息负责，确保录入信息与实际一致。</p>"+
            "<p style='font-weight: 800;'>2、严格审核原则。双方审核人员除了严格审核己方录入信息外，还须要严格审核对方录入的信息是否符合自身要求。</p>"+
            "<p style='font-weight: 800;'>3、订单备注优先原则。备注视为协议的补充条款，拥有最高的优先级。</p>"+
            "<p>解释1：证书职位匹配后，不管是因为疏忽还是故意，若订单出现问题，而且问题发生的原因在于录入信息与实际不一致，除特殊情况外，由录入方承担主要责任。</p>"+
            "<p>案例1-1：如果人才合同签的是考B证，而人才录入是带B证（与实际不一致），企业需求的是带B证，订单形成后，因B证问题导致企业退证退款，主要责任方在人才方。同理，只要企业方录入信息与实际不一致，主要责任在企业方。</p>"+
            "<p>特殊案例1-2：如果人才签的是项目合同，人才方和企业方录入的也都是项目，订单形成后，因人才反悔不愿意上项目导致退证退款，分两种情况处理。如果人才方业务员能提供与人才签的项目合同（原件或扫描件），且该合同和人才本人出示的合同一致，问题出在人才自身，那么这种情况属于天灾人祸，责任由双方共同承担。如果人才方提供的合同与人才本人提供的合同在关键信息上不一致，则由人才方承担主要责任。</p>"+
            "<p>特殊案例1-3：同上，如果人才签的是唯一社保合同，人才方和企业方录入的都是唯一社保，订单形成后，因人才原因不能配合社保，分两种情况处理。如果人才方能提供与人才签的唯一社保合同（原件或扫描件），且该合同和人才本人出示的合同一致，并且提供真实标准的唯一社保视频及证明（附录：唯一社保视频模板），问题出在人才自身，那么这种情况属于天灾人祸，责任由双方共同承担。如果人才方提供的合同与人才本人提供的合同在关键信息上不一致，或没有提供真实有效社保证明视频、停社保证明等凭证，那么由人才方承担主要责任。</p>"+
            "<p>案例1-4：人才方收到假证、复制证、问题证，如果匹配时该情况已经备注，视为信息与实际一致，一旦发生问题，双方共同承担责任。如果情况未备注，视为信息与实际不一致，人才方承担主要责任。</p>"+
            "<p>案例1-5：双方录入信息都和实际一致，但某方突然提出取消订单（可能是人才突然不想注册了，或者企业突然不要这本证了），视同违约，由取消订单一方承担主要责任。</p>"+
            "<p>解释2：如果双方录入信息与实际一致，不管双方供需是否匹配，双方均无协议内的过错，若出现问题，责任由双方共同承担。</p>"+
            "<p>案例2-1：人才录入信息上没有备注人才出场费，企业录入信息上没有备注企业提供的出场费，匹配的时候双方业务员也没有关注人才出场费的事情，证书注册成功后，人才对出场费不满导致退证，不管人才、企业原始合同上是否注明有出场费，双方共同承担责任；</p>"+
            "<p>案例2-2：人才方录入的是私企社保（与合同一致），企业方录入的是唯一社保（与合同一致），并且无特殊备注。订单一旦匹配审批成功，不管是因为双方将私企社保用于唯一社保，还是双方业务员及审批人员疏忽，视为双方都了解并同意该情况，万一企业无法使用私企社保证书导致退款并造成损失，由人才、企业双方共同承担。</p>"+
            "<p>特殊案例2-3：人才、企业双方录入与实际一致，但建筑公司长期拖欠，且人才部、企业部双方共同催收后依然无法收回全部款项，分为两种情况。如果建筑公司依然有还款能力，而人才怒而退证，由双方共同承担责任。如果建筑公司丧失还款能力，人去楼空了无音讯，企业方承担主要责任。</p>"+
            "<p>解释3：双方审批人员务必要求己方业务员在录入信息时严肃认真，务必认真审核己方和对方的相关信息，务必妥善保管原始合同，因为这是纠纷出现后保护己方利益的最有利凭证。</p>"+
            "<p>解释4：备注视为协议的补充条款，优先于订单中其他信息。所以请务必将自身情况备注清楚，且重视对方的备注。但凡在备注中注明清楚情况，且对方审核通过，则该“备注”为共同约定的条款，但凡违约，由违约方承担主要责任。</p>"+
            "<p>案例4-1：人才方在系统中备注“不能出场”。企业方在系统中没有备注。订单匹配后，因企业突然需要人才出场而人才不能配合，导致退证退款，由企业方承担主要责任。</p>"+
            "<p>案例4-2：人才方业务员在备注中注明“己方提供的是私企社保，一旦社保被查，人才按比例退款”。订单匹配后，如果建筑公司被查后要求退全款，因此造成损失，由企业方承担主要责任。</p>"+
            "<p>案例4-3：某方可特别备注“该笔订单由对方承担全部责任”，一旦订单形成，视同对方认同该条款。未来如果订单产生问题，可由对方全责。</p>"+
            "<p style='font-weight: 800;'>二、责任划分为三种情况，1、责任双方均担；2、责任分为主要责任人和次要责任人；3、特殊约定由某方全部承担。</p>"+
            "<p>重要：无论责任方是哪边，人才、企业双方应积极负责的共同协商处理订单中出现的问题，即便造成损失，双方也要争取把损失降到最低。业务一经双方确认形成订单，业务双方均对该笔业务负有责任，无论双方各承担多少，一起处理问题，一共承担损失的大原则是平台下各方得以长期合作的基石。</p>"+
            "<p>解释1：双方分别承担50%的责任，造成的损失也由双方按比例承担。</p>"+
            "<p>解释2：主要责任人承担70%责任，次要责任人承担30%责任。造成的损失也按照比例承担。注：有可能承担的70%损失已经足够警示每一家公司做好先期审核工作，30%的保底损失足够每一家公司在出了问题后都能尽心尽力处理。</p>"+
            "<p>解释3：订单中各方的备注属于特殊约定，一旦备注中商定某种情况由某方全部承担，且对方审批通过，则该笔订单的责任乃至损失都由某方全部承担。</p>"+
            "<p style='font-weight: 800;'>三、以上内容的解释权归本服务平台所有，具体以最新公告为准。</p></div>";
        layer.open({
            type: 1
            ,title: "请先阅读" //不显示标题栏
            ,closeBtn: false
            ,area: ['700px', '500px']
            ,shade: 0.5
            ,shadeClose:true
            ,offset:'auto'
            ,id: 'lay_noticeopen' //设定一个id，防止重复弹出
            ,resize: false
            ,btn: ['阅读完毕', '取消']
            ,btnAlign: 'c'
            ,moveType: 1 //拖拽模式，0或者1
            ,content: htm
            ,yes: function(index,layero){
                Common.parentOpenDlg(url,title);
                layer.close(index);
            }
        });
    }
};


// JQuery方法定制
(function ($) {


    $.ajaxSetup({
        type: 'POST',
        async: true,
        dataType: "json",
        timeout: 30000
    });

    /**
     * 获取form表单数据
     */
    $.fn.getFormData = function (isValid) {
        var fieldElem = $(this).find('input,select,textarea'); //获取所有表单域
        var data = {};
        layui.each(fieldElem, function (index, item) {
            if (!item.name) return;
            if (/^checkbox|radio$/.test(item.type) && !item.checked) return;
            var value = item.value;
            if (item.type == "checkbox") {//如果多选
                if (data[item.name]) {
                    value = data[item.name] + "," + value;
                }
            }
            if (isValid) {
                //如果为true,只需要处理有数据的值
                if (!$.isEmpty(value)) {
                    data[item.name] = value;
                }
            } else {
                data[item.name] = value;
            }
        });
        return data;
    };

    $.fn.serializeJson = function () {
        var serializeObj = {};
        var array = this.serializeArray();
        var str = this.serialize();
        $(array).each(
            function () {
                if (serializeObj[this.name]) {
                    if ($.isArray(serializeObj[this.name])) {
                        serializeObj[this.name].push(this.value);
                    } else {
                        serializeObj[this.name] = [
                            serializeObj[this.name], this.value];
                    }
                } else {
                    serializeObj[this.name] = this.value;
                }
            });
        return serializeObj;
    };


    $.extend({
        //非空判断
        isEmpty: function (value) {
            if (value == "" || value == " " || value == undefined || value == "undefined" | value == "[]" || value == null || value == 'null' || value.length <= 0 || $.trim(value).length <= 0) {
                return true;
            }
            return false;
        }, isRealNum: function (val) {//判断是否是数值
            // isNaN()函数 把空串 空格 以及NUll 按照0来处理 所以先去除，
            if (val === "" || val == null) {
                return true;
            }
            if (!isNaN(val)) {
                return false;
            } else {
                return true;
            }
        },
        //获取对象指
        result: function (object, path, defaultValue) {
            var value = "";
            if (!$.isEmpty(object) && $.isObject(object) && !$.isEmpty(path)) {
                var paths = path.split('.');
                var length = paths.length;
                $.each(paths, function (i, v) {
                    object = object[v];
                    if (length - 1 == i) {
                        value = object;
                    }
                    if (!$.isObject(object)) {
                        return false;
                    }
                })

            }

            if ($.isEmpty(value) && !$.isEmpty(defaultValue)) {
                value = defaultValue;
            }
            return value;
        },
        //判断是否obj对象
        isObject: function (value) {
            var type = typeof value;
            return value != null && (type == 'object' || type == 'function');
        },
        //是否以某个字符开头
        startsWith: function (value, target) {
            return value.indexOf(target) == 0;
        },
        //设置sessionStorage
        setSessionStorage: function (key, data) {
            sessionStorage.setItem(key, data);
        },
        //获取sessionStorage
        getSessionStorage: function (key) {
            return sessionStorage.getItem(key) == null ? "" : sessionStorage.getItem(key);
        },
        //删除sessionStorage
        removeSessionStorage: function (key) {
            sessionStorage.removeItem(key);
        },
        //清除sessionStorage
        clearSessionStorage: function () {
            sessionStorage.clear();
        },
        uuid: function () {
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            });
        },
        timeInterception: function (t, l) {
            if (t != null || t != undefined || t != "") {
                return t.substring(0, l);
            } else {
                return "";
            }
        },getUrlParam:function(name) {//获取url中的参数
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
            var r = window.location.search.substr(1).match(reg);  //匹配目标参数
            if (r != null) return unescape(r[2]); return null; //返回参数值
        }
    });

}(jQuery));
