/**
 * @Description: 菜单管理
 * @Copyright: 2017 www.fallsea.com Inc. All rights reserved.
 * @author: fallsea
 * @version 1.6.1
 * @License：MIT
 */
layui.define(['element'], function (exports) {
    var element = layui.element,
        FsTab = function () {
            this.config = {
                topMenuFilter: "fsTopMenu",//头部菜单
                leftMenuFilter: "fsLeftMenu",//左边菜单
                tabFilter: "fsTab"//导航栏
            }
        };


    FsTab.prototype.render = function (options) {
        var thisTab = this;
        $.extend(true, thisTab.config, options);

        thisTab.bindDeleteFilter();//调动删除监听

        thisTab.bindTabFilter();//调动：监听tab切换，处理菜单选中

        //绑定左边菜单点击。
        element.on('nav(' + thisTab.config.leftMenuFilter + ')', function (elem) {
            elem = $(elem).parent();
            var layId = $(elem).attr("lay-id");
            if ($.isEmpty(layId)) {
                //layId = $.uuid();自己改的
                $(elem).attr("lay-id", layId);
                var dom = $(elem).find("a");
                var title = $(elem).find("a").html();
                var dataUrl = dom.attr("dataUrl");
                layId = dom.attr("menuid");//自己改的
                $(elem).attr("lay-id", layId);
                if (!$.isEmpty(dataUrl)) {
                    if(dataUrl.indexOf("http://") >= 0 || dataUrl.indexOf("https://") >= 0){
                        dataUrl = dataUrl.replace("/server","");
                    }
                    if(layId == '141' || layId == '142' || layId == '143'){ // 护换线请求 护换线应答 护换线检验 等页面直接通过新页面打开
                        $(elem).attr("lay-id", "");
                        window.open(dataUrl);
                    }else {
                        thisTab.add(title, dom.attr("dataUrl"), layId);
                    }
                }
            }
            if (layId == 70) {
                Lib.closeOrder();
            }
            thisTab.tabChange(layId);
            $('body').removeClass('site-mobile');
        });

        //监听关闭tab
        element.on('tabDelete(' + this.config.tabFilter + ')', function (data) {
            var li = $(this).parent();
            var layId = $(li).attr("lay-id");//仔细看
            //删除tab上标记
            var dl = $("#fsLeftMenu").find("[lay-id='" + layId + "']");
            $(dl).attr("lay-id", "");
            if (layId == 70) {
                Lib.closeOrder();
            }
        });
    };

    /**
     * 切换tab
     */
    FsTab.prototype.tabChange = function (layId) {
        element.tabChange(this.config.tabFilter, layId);
        /*--------------添加该段代码表示重新加载页面--------------*/
        var othis = $('.layui-tab-title').find('>li[lay-id="' + layId + '"]'),
            index = othis.parent().children('li').index(othis),
            parents = othis.parents('.layui-tab').eq(0),
            item = parents.children('.layui-tab-content').children('.layui-tab-item'),
            src = item.eq(index).find('iframe').attr("src");
        item.eq(index).find('iframe').attr("src", src);
        /*--------------添加该段代码表示重新加载页面--------------*/
    }

    /**
     * 新增，添加选项卡
     */
    FsTab.prototype.add = function (title, dataUrl, layId) {
        var tag = 0;
        if (dataUrl.indexOf("order/index.do") >= 0) {
            Lib.closeOrder();
        }
        var len = $(".fsTab .layui-tab-title li").length;
        var n = 0;
        for (var i = 0; i < len; i++) {
            if ($(".fsTab .layui-tab-title li:eq(" + i + ")").attr("lay-id") == layId) {
                n = 1;
            }
        }
        if (n == 0) {
            if(dataUrl.indexOf("http://") >= 0 || dataUrl.indexOf("https://") >= 0){
                dataUrl = dataUrl.replace("/server","");
            }
            element.tabAdd(this.config.tabFilter, {
                title: title
                , content: '<iframe id="view_' + layId + '" src="' + dataUrl + '"></iframe>' //支持传入html
                , id: layId
            });
        }
        this.deleteTab(layId);//在每个添加选项卡中添加右键点击事件
    };

    /**
     * 删除监听
     */
    FsTab.prototype.bindDeleteFilter = function () {
        element.on('tabDelete(' + this.config.tabFilter + ')', function (data) {
            var layId = $(this).parentsUntil().attr("lay-id");
            $('.fsMenu .layui-nav-child>dd[lay-id="' + layId + '"],.fsMenu>li[lay-id="' + layId + '"]').removeAttr("lay-id");
        });
    }

    /**
     * 监听tab切换，处理菜单选中
     */
    FsTab.prototype.bindTabFilter = function () {
        var thisTab = this;
        element.on('tab(' + this.config.tabFilter + ')', function (data) {
            var layId = $(this).attr("lay-id");
            thisTab.menuSelectCss(layId);
        });
    }

    /**
     * 菜单选中样式
     */
    FsTab.prototype.menuSelectCss = function (layId) {
        if (!$.isEmpty(layId)) {
            $('.fsMenu .layui-this').removeClass("layui-this");//清除样式

            var dom = $('.fsMenu .layui-nav-child>dd[lay-id="' + layId + '"],.fsMenu>li[lay-id="' + layId + '"]');
            dom.addClass("layui-this");//追加样式

            //处理头部菜单
            if (dom.length == 1) {
                var dataPid = null;
                var tagName = dom.get(0).tagName;
                if (tagName == "LI") {
                    dataPid = dom.attr("dataPid");
                } else if (tagName == "DD") {
                    dataPid = dom.parentsUntil('li').parent().attr("dataPid");
                }
                if (!$.isEmpty(dataPid)) {
                    $('#fsTopMenu li[dataPid="' + dataPid + '"]').click();
                }
            }
        }
    }


    FsTab.prototype.deleteTab = function (layId) {

        $('.fsTab .layui-tab-title li[lay-id="' + layId + '"]').mousedown(function (e) {
            if (e.which == 3) {//alert("鼠标点击了右键");
                /*加载右键tab表单：rightmenu的值*/
                // 阻止浏览器鼠标右键单击事件
                $('.layui-tab-title li').bind('contextmenu', function () {return false;});
                $('.fsTab .layui-tab-title').click(function () { $('.rightmenu').hide(); });
                //tab点击右键rightmenu位置
                var popupmenu = $(".rightmenu");
                popupmenu.find("li").attr("lay-id", layId);
                l = ($(document).width() - e.clientX) < popupmenu.width() ? (e.clientX - popupmenu.width()) : e.clientX;
                t = ($(document).height() - e.clientY) < popupmenu.height() ? (e.clientY - popupmenu.height()) : e.clientY;
                popupmenu.css({left: l - 190, top: t - 50}).show(); //进行绝对定位
            }

            /*
                右键菜单中的选项被点击之后，判断type的类型，决定关闭所有还是关闭当前。
                layId不能完全代替下面的$(this).attr("lay-id")，系统不能与值做比较。则关闭效果失效

                 */
            $(".rightmenu li").click(function () {
                var layId = $(this).attr("lay-id");//右击时lay-id的值
                if ($(this).attr("data-type") == "closethis") {//关闭这个
                    element.tabDelete('fsTab', layId);
                    $("#fsLeftMenu").find("[lay-id='" + layId + "']").attr("lay-id", "");
                } else if ($(this).attr("data-type") == "closeothe") {//关闭其他
                    var tabtitle = $(".layui-tab-title li");
                    var layIds = new Array();
                    $.each(tabtitle, function (i) {
                        if (layId != $(this).attr("lay-id")) {//$(this).attr("lay-id")遍历时每个lay-id的值
                            layIds[i] = $(this).attr("lay-id");
                            if ($(this).attr("lay-id") != '1_1_1') {
                                element.tabDelete('fsTab', $(this).attr("lay-id"));
                                $("#fsLeftMenu").find("[lay-id='" + layIds[i] + "']").attr("lay-id", "");
                            }
                        }
                    });
                } else if ($(this).attr("data-type") == "closeright") {//关闭右侧
                    var tabtitle = $(".layui-tab-title li[lay-id=" + layId + "]~li");
                    var layIds = new Array();
                    $.each(tabtitle, function (i) {
                        layIds[i] = $(this).attr("lay-id");
                        if ($(this).attr("lay-id") != '1_1_1') {
                            element.tabDelete('fsTab', $(this).attr("lay-id"));
                            $("#fsLeftMenu").find("[lay-id='" + layIds[i] + "']").attr("lay-id", "");
                        }
                    });
                } else if ($(this).attr("data-type") == "closeleft") {//关闭左侧
                    var tabtitle = $(".layui-tab-title li");
                    var layIds = new Array();
                    $.each(tabtitle, function (i) {
                        layIds[i] = $(this).attr("lay-id");
                        if (layId == $(this).attr("lay-id")) {
                            return false; //跳出循环
                        }else {
                            if ($(this).attr("lay-id") != '1_1_1') {
                                element.tabDelete('fsTab', $(this).attr("lay-id"));
                                $("#fsLeftMenu").find("[lay-id='" + layIds[i] + "']").attr("lay-id", "");
                            }
                        }
                    });
                } else if ($(this).attr("data-type") == "closeall") {//关闭所有
                    var tabtitle = $(".layui-tab-title li");
                    var layIds = new Array();
                    $.each(tabtitle, function (i) {
                        layIds[i] = $(this).attr("lay-id");
                        if ($(this).attr("lay-id") != '1_1_1') {
                            element.tabDelete('fsTab', $(this).attr("lay-id"));
                            $("#fsLeftMenu").find("[lay-id='" + layIds[i] + "']").attr("lay-id", "");
                        }
                    });
                }
                $('.rightmenu').hide(); //最后再隐藏右键菜单
            });
        });
    }

    var fsTab = new FsTab();
    //绑定按钮
    exports("fsTab", fsTab);
});