var webSocket = {
    //开启socket
    socket:null,
    socketConnect:null,
    reconnectCount:0,
    openSocket:function (webSocketServer,userId,page){ //webSocketServer:请求地址 userId:人员ID page:所属页面
        if (typeof (WebSocket) == "undefined") {
            console.log("您的浏览器不支持WebSocket");
            Common.info("您的浏览器不支持WebSocket");
        } else {
            //实现化WebSocket对象，指定要连接的服务器地址与端口  建立连接
            //等同于socket = new WebSocket("ws://localhost:8888/xxxx/im/25");
            //var socketUrl="${request.contextPath}/im/"+$("#userId").val();
            //var socketUrl = "http://localhost:9090/server/imserver/" + $("#userId").val();
            var socketUrl = webSocketServer + "/imserver/" + userId;
            socketUrl = socketUrl.replace("https", "ws").replace("http", "ws");
            if (webSocket.socket != null) {
                webSocket.socket.close();
                webSocket.socket = null;
            }
            webSocket.socket = new WebSocket(socketUrl);
            //打开事件
            webSocket.socket.onopen = function () {
                heartCheck.reset().start();   // 成功建立连接后，重置心跳检测
                console.log("websocket已打开");
                //webSocket.socket.send("这是来自客户端的消息" + location.href + new Date());
                if (webSocket.reconnectCount == 1) {
                    clearInterval(webSocket.socketConnect);
                    webSocket.reconnectCount = 0;
                }
            };
            //获得消息事件
            webSocket.socket.onmessage = function (msg) {
                console.log("socket返回值：");
                console.log(msg);
                heartCheck.reset().start();    // 如果获取到消息，说明连接是正常的，重置心跳检测
                if (msg.data != "连接成功") {
                    var d = JSON.parse(msg.data);
                    // 1. message 首页
                    if(d.type == "message" && page == "index"){
                        loadInfo();
                    }
                }
                //发现消息进入 开始处理前端触发逻辑
            };
            //关闭事件
            webSocket.socket.onclose = function () {
                console.log("websocket已关闭");
                if (webSocket.reconnectCount == 0) {
                    webSocket.reconnectCount = 1;
                    webSocket.socketConnect = setInterval(function () {
                        webSocket.openSocket(webSocketServer,userId,page);//关闭时自动连接 5秒连接一次
                    }, 5000);
                }
            };
            //发生了错误事件
            webSocket.socket.onerror = function () {
                console.log("websocket发生了错误");
            }

            // 心跳检测, 每隔一段时间检测连接状态，如果处于连接中，就向server端主动发送消息，来重置server端与客户端的最大连接时间，如果已经断开了，发起重连。
            var heartCheck = {
                timeout: 20000,        // 发一次心跳，比server端设置的连接时间稍微小一点，在接近断开的情况下以通信的方式去重置连接时间。20000
                serverTimeoutObj: null,
                reset: function () {
                    clearTimeout(this.timeoutObj);
                    clearTimeout(this.serverTimeoutObj);
                    return this;
                },
                start: function () {
                    var self = this;
                    this.serverTimeoutObj = setInterval(function () {
                        if (webSocket.socket.readyState == 1) {
                            console.log("连接状态，发送消息保持连接");
                            var sign = localStorage.getItem("_sign");//获取缓存参数
                            webSocket.socket.send("{\"message\":\"ping\",\"sign\":\"" + sign + "\"}");
                            heartCheck.reset().start();    // 如果获取到消息，说明连接是正常的，重置心跳检测
                        } else {
                            console.log("断开状态，尝试重连");
                            webSocket.openSocket(webSocketServer,userId,page);
                        }
                    }, this.timeout);
                }
            }
        }
    },socketEnd:function(){
        webSocket.socket.close();
    }
}

